// MDIView.cpp : implementation of the CMDIView class
//

#include "stdafx.h"
#include "MDI.h"

#include "MDIDoc.h"
#include "MDIView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMDIView

IMPLEMENT_DYNCREATE(CMDIView, CEditView)

BEGIN_MESSAGE_MAP(CMDIView, CEditView)
	//{{AFX_MSG_MAP(CMDIView)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)

  ON_UPDATE_COMMAND_UI_RANGE(10000,10500, OnUpdateFileRange) 
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMDIView construction/destruction

CMDIView::CMDIView()
{
	// TODO: add construction code here

}

CMDIView::~CMDIView()
{
}

BOOL CMDIView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// CMDIView drawing

void CMDIView::OnDraw(CDC* pDC)
{
  UNREFERENCED_PARAMETER(pDC);
	CMDIDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CMDIView printing

BOOL CMDIView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CEditView preparation
	return CEditView::OnPreparePrinting(pInfo);
}

void CMDIView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView begin printing.
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CMDIView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView end printing
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CMDIView diagnostics

#ifdef _DEBUG
void CMDIView::AssertValid() const
{
	CEditView::AssertValid();
}

void CMDIView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CMDIDoc* CMDIView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMDIDoc)));
	return (CMDIDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMDIView message handlers

static CString GetShort(UINT id)
{
	CString str;
	str.LoadString(id);
	int nIndex = str.ReverseFind(_T('\n'));
	if(nIndex!=-1)
	{
		str=str.Mid(nIndex+1);
	}
	return str;
}

void CMDIView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
  UNREFERENCED_PARAMETER(pWnd);
	if(point.x==-1 && point.y==-1)
	{
		CRect rect;
		GetWindowRect(rect);

		point = rect.TopLeft()+CPoint(10,10);
	}
	SetFocus();

	CNewMenu menu;
	menu.CreatePopupMenu();
	menu.InsertMenu(0, MF_BYPOSITION , ID_EDIT_UNDO, GetShort(ID_EDIT_UNDO));
	menu.InsertMenu(1, MF_BYPOSITION|MF_SEPARATOR);
	menu.InsertMenu(2, MF_BYPOSITION , ID_EDIT_COPY, GetShort(ID_EDIT_COPY));
	menu.InsertMenu(2, MF_BYPOSITION , ID_EDIT_CUT, GetShort(ID_EDIT_CUT));
	menu.InsertMenu(4, MF_BYPOSITION , ID_EDIT_CLEAR, GetShort(ID_EDIT_CLEAR));
	menu.InsertMenu(5, MF_BYPOSITION , ID_EDIT_PASTE, GetShort(ID_EDIT_PASTE));
	menu.InsertMenu(6, MF_BYPOSITION|MF_SEPARATOR);

	menu.InsertMenu(7, MF_BYPOSITION , ID_EDIT_SELECT_ALL,GetShort(ID_EDIT_SELECT_ALL));
	menu.InsertMenu(8, MF_BYPOSITION|MF_SEPARATOR);
	menu.InsertMenu(9, MF_BYPOSITION , ID_FILE_NEW,_T("Test file new"));

	menu.SetMenuTitle(_T("Edit commands"),MFT_GRADIENT|MFT_SIDE_TITLE|MFT_LINE);

  CNewMenu* pSubMenu = menu.AppendODPopupMenu(_T("NewMenu"));
  pSubMenu->SetBitmapBackground(RGB(192,192,192));
  UINT nIDs[] = {IDB_FILE_A,IDB_FILE_B,IDB_FOLDER_A,IDB_FOLDER_B};
  for(int n=0;n<80;n++)
  {
    CString str;
    str.Format(_T("File %2ld"),1+n);
    pSubMenu->InsertODMenu(n, str,MF_BYPOSITION , n+10000, nIDs[n&3]);
  }

  pSubMenu = menu.AppendODPopupMenu(_T("NewMenu Sub"));
  pSubMenu->InsertMenu(0, MF_BYPOSITION , ID_EDIT_UNDO, GetShort(ID_EDIT_UNDO));;
	pSubMenu->InsertMenu(1, MF_BYPOSITION | MF_SEPARATOR);
	pSubMenu->InsertMenu(2, MF_BYPOSITION , ID_EDIT_COPY, GetShort(ID_EDIT_COPY));

  pSubMenu = pSubMenu->AppendODPopupMenu(_T("NewMenu Sub 3"));
  pSubMenu->InsertMenu(0, MF_BYPOSITION , ID_EDIT_UNDO, GetShort(ID_EDIT_UNDO));;
	pSubMenu->InsertMenu(1, MF_BYPOSITION | MF_SEPARATOR);
	pSubMenu->InsertMenu(2, MF_BYPOSITION , ID_EDIT_COPY, _T("&Copy"));
  // add an empty!!
	pSubMenu->InsertMenu(3, MF_BYPOSITION , ID_EDIT_CLEAR, _T(""));

  CMenu mmm;
  mmm.CreatePopupMenu();
  // the width of that menuitem will not calculated right!!!
  menu.AppendMenu(MF_POPUP,(UINT)(UINT_PTR)mmm.m_hMenu,_T("Window Default"));
  mmm.InsertMenu(0, MF_BYPOSITION , ID_EDIT_UNDO, GetShort(ID_EDIT_UNDO));;
	mmm.InsertMenu(1, MF_BYPOSITION | MF_SEPARATOR);
	mmm.InsertMenu(2, MF_BYPOSITION , ID_EDIT_COPY, _T("&Copy"));

	menu.LoadToolBar(IDR_MAINFRAME); 
  menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, AfxGetMainWnd());
}

void CMDIView::OnUpdateFileRange(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(pCmdUI->m_nID&3);
  pCmdUI->Enable((pCmdUI->m_nID>>2)&1);
}