// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MDI.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CNewMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CNewMDIFrameWnd)
  //{{AFX_MSG_MAP(CMainFrame)
    // NOTE - the ClassWizard will add and remove mapping macros here.
    //    DO NOT EDIT what you see in these blocks of generated code !
  ON_WM_CREATE()
  //}}AFX_MSG_MAP
  ON_COMMAND(ID_NEWMENU_NEXTSTYLE, OnNewMenuNextStyle)
  ON_UPDATE_COMMAND_UI(ID_NEWMENU_NEXTSTYLE, OnUpdateNewMenuNextStyle)
  ON_COMMAND(ID_NEWMENU_SHOWSELECTION, OnNewMenuShowSelection)
  ON_UPDATE_COMMAND_UI(ID_NEWMENU_SHOWSELECTION, OnUpdateNewMenuShowSelection)
  ON_COMMAND(ID_NEWMENU_NORMALBORDER, OnNewMenuNormalBorder)
  ON_UPDATE_COMMAND_UI(ID_NEWMENU_NORMALBORDER, OnUpdateNewMenuNormalBorder)
  ON_COMMAND(ID_NEWMENU_ENABLEGLOOM, OnNewMenuEnableGloom)
  ON_UPDATE_COMMAND_UI(ID_NEWMENU_ENABLEGLOOM, OnUpdateNewMenuEnableGloom)
  ON_COMMAND(ID_NEWMENU_ALLMENUSAMEBORDER, OnNewMenuAllSameBorder)
  ON_UPDATE_COMMAND_UI(ID_NEWMENU_ALLMENUSAMEBORDER, OnUpdateNewMenuAllSameBorder)
  ON_COMMAND_RANGE(ID_EXPLORER_BACK,ID_EXPLORER_MORE, OnExplorer)
  ON_UPDATE_COMMAND_UI(ID_EXPLORER_HOME, OnUpdateExplorerHome)
  ON_UPDATE_COMMAND_UI(ID_EXPLORER_REFRESH, OnUpdateExplorerRefresh)
  ON_UPDATE_COMMAND_UI(ID_EXPLORER_STOP, OnUpdateExplorerStop)
  ON_UPDATE_COMMAND_UI(ID_EXPLORER_FORWARD, OnUpdateExplorerForward)
  ON_COMMAND(ID_OBJECT_LINECOLOR, OnObjectLinecolor)
  ON_COMMAND(ID_ObjectUp, OnObjectUp)
  ON_COMMAND(ID_ObjectTop, OnObjectTop)
  ON_COMMAND(ID_ObjectDown, OnObjectDown)
  ON_COMMAND(ID_ObjectBottom, OnObjectBottom)
  ON_UPDATE_COMMAND_UI(ID_OBJECT_LINECOLOR, OnUpdateObjectLinecolor)
END_MESSAGE_MAP()

static UINT indicators[] =
{
  ID_SEPARATOR,           // status line indicator
  ID_INDICATOR_CAPS,
  ID_INDICATOR_NUM,
  ID_INDICATOR_SCRL,
};


/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
  // TODO: add member initialization code here
  
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  if (CNewMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
    return -1;

  //ModifyStyleEx(0,WS_EX_LAYOUTRTL);
  
  if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
    | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
    !m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
  {
    TRACE0("Failed to create toolbar\n");
    return -1;      // fail to create
  }

  if (!m_wndStatusBar.Create(this) ||
    !m_wndStatusBar.SetIndicators(indicators,
      sizeof(indicators)/sizeof(UINT)))
  {
    TRACE0("Failed to create status bar\n");
    return -1;      // fail to create
  }

  m_DefaultNewMenu.LoadToolBar(IDR_MAINFRAME);

  m_SystemNewMenu.SetMenuTitle(_T("MDI Sample"),MFT_SUNKEN|MFT_LINE|MFT_CENTER|MFT_SIDE_TITLE);

  // TODO: Delete these three lines if you don't want the toolbar to
  //  be dockable
  m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
  EnableDocking(CBRS_ALIGN_ANY);
  DockControlBar(&m_wndToolBar);

  return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
  if( !CNewMDIFrameWnd::PreCreateWindow(cs) )
    return FALSE;
  // TODO: Modify the Window class or styles here by modifying
  //  the CREATESTRUCT cs

  return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
  CNewMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
  CNewMDIFrameWnd::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnNewMenuNextStyle() 
{
  int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2)+2;

  if(nStyle>CNewMenu::STYLE_ICY_NOBORDER)
    nStyle = CNewMenu::STYLE_ORIGINAL+(nStyle&1);

  int nActStyle = CNewMenu::GetMenuDrawMode();
  AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Style"),nStyle);
  if(nActStyle!=nStyle)
  {
    // Subclass dialog with system menu
    CNewMenuHelper myHelper(NEW_MENU_DIALOG_SUBCLASS|NEW_MENU_DIALOG_SYSTEM_MENU);
    AfxMessageBox(_T("You must restart the application for changing the menu style"),MB_OK);
  }
}

void CMainFrame::OnUpdateNewMenuNextStyle(CCmdUI* pCmdUI) 
{
  int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2);
  int nActStyle = CNewMenu::GetMenuDrawMode();
  pCmdUI->SetCheck(nStyle==nActStyle);

  switch(nStyle)
  {
  case CNewMenu::STYLE_ORIGINAL:
    pCmdUI->SetText(_T("Original new border"));
    break;

  case CNewMenu::STYLE_ORIGINAL_NOBORDER:
    pCmdUI->SetText(_T("Original old border"));
    break;

  case CNewMenu::STYLE_ICY:
    pCmdUI->SetText(_T("Icy new border"));
    break;

  case CNewMenu::STYLE_ICY_NOBORDER:
    pCmdUI->SetText(_T("Icy old border"));
    break;

  case CNewMenu::STYLE_XP:
    pCmdUI->SetText(_T("XP new border"));
    break;

  case CNewMenu::STYLE_XP_NOBORDER:
    pCmdUI->SetText(_T("XP old border"));
    break;

  case CNewMenu::STYLE_SPECIAL:
    pCmdUI->SetText(_T("Special new border"));
    break;

  case CNewMenu::STYLE_SPECIAL_NOBORDER:
    pCmdUI->SetText(_T("Special old border"));
    break;
  }
}

void CMainFrame::OnNewMenuShowSelection() 
{
  BOOL bMode = CNewMenu::GetSelectDisableMode()?FALSE:TRUE;
  AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Selection"),bMode);
  CNewMenu::SetSelectDisableMode(bMode);
}

void CMainFrame::OnUpdateNewMenuShowSelection(CCmdUI* pCmdUI) 
{
  pCmdUI->SetCheck(CNewMenu::GetSelectDisableMode());
}

void CMainFrame::OnNewMenuNormalBorder() 
{
  int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2);

  int nActStyle = CNewMenu::GetMenuDrawMode()&~1;
  CNewMenu::SetMenuDrawMode(nActStyle|((nStyle^1)&1));

  AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Style"),nStyle^1);
}

void CMainFrame::OnUpdateNewMenuNormalBorder(CCmdUI* pCmdUI) 
{
  pCmdUI->SetRadio(TRUE);
  if(CNewMenu::GetMenuDrawMode()&1)
  {
    pCmdUI->SetText(_T("Old border"));
  }
  else
  {
    pCmdUI->SetText(_T("New border"));
  }
}

void CMainFrame::OnNewMenuAllSameBorder()
{
  CNewMenu::SetNewMenuBorderAllMenu(CNewMenu::GetNewMenuBorderAllMenu()?FALSE:TRUE);
}

void CMainFrame::OnUpdateNewMenuAllSameBorder(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(CNewMenu::GetNewMenuBorderAllMenu());
}

void CMainFrame::OnNewMenuEnableGloom() 
{
  CNewMenu::SetXpBlendig(CNewMenu::GetXpBlendig()?FALSE:TRUE);
  AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Gloom"),CNewMenu::GetXpBlendig());
}

void CMainFrame::OnUpdateNewMenuEnableGloom(CCmdUI* pCmdUI) 
{
  if(CNewMenu::GetMenuDrawMode()==CNewMenu::STYLE_XP ||
     CNewMenu::GetMenuDrawMode()==CNewMenu::STYLE_XP_NOBORDER)
  {
    pCmdUI->Enable(TRUE);
  }
  else
  {
    pCmdUI->Enable(FALSE);
  }
  pCmdUI->SetCheck(CNewMenu::GetXpBlendig());
}

void CMainFrame::OnExplorer(UINT nID)
{
  UNREFERENCED_PARAMETER(nID);

  //CNewFileDialog myFile(true);
  //myFile.DoModal();
  CNewMenuHelper myHelper(NEW_MENU_DIALOG_SUBCLASS|NEW_MENU_DIALOG_SYSTEM_MENU|NEW_MENU_DEFAULT_BORDER);

  CFontDialog FontDialog;
  FontDialog.DoModal();

}

void CMainFrame::OnUpdateExplorerHome(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(2);
  pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateExplorerStop(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(0);
  pCmdUI->Enable(TRUE);
}

void CMainFrame::OnUpdateExplorerForward(CCmdUI* pCmdUI)
{
  pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateExplorerRefresh(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(1);
  pCmdUI->Enable(TRUE);
}

void CMainFrame::OnObjectLinecolor() 
{
}

void CMainFrame::OnObjectUp() 
{
}

void CMainFrame::OnObjectTop() 
{
}

void CMainFrame::OnObjectDown() 
{
}

void CMainFrame::OnObjectBottom() 
{
}

void CMainFrame::OnUpdateObjectLinecolor(CCmdUI* pCmdUI) 
{
  pCmdUI->SetCheck();
}
