// MDI.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MDI.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MDIDoc.h"
#include "MDIView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMDIApp

BEGIN_MESSAGE_MAP(CMDIApp, CWinApp)
  //{{AFX_MSG_MAP(CMDIApp)
  ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
    // NOTE - the ClassWizard will add and remove mapping macros here.
    //    DO NOT EDIT what you see in these blocks of generated code!
  //}}AFX_MSG_MAP
  // Standard file based document commands
  ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
  ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
  // Standard print setup command
  ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMDIApp construction

CMDIApp::CMDIApp()
{
  // TODO: add construction code here,
  // Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMDIApp object

CMDIApp theApp;
static WORD ToolId2[] = { IDB_TOOLBAR24,
                        24, 24,
                        ID_EXPLORER_BACK,
                        ID_EXPLORER_FORWARD,
                        ID_EXPLORER_STOP,
                        ID_EXPLORER_REFRESH,
                        ID_EXPLORER_HOME,
                        ID_EXPLORER_SEARCH,
                        ID_EXPLORER_FAVORITES,
                        ID_EXPLORER_PRINT,
                        ID_EXPLORER_SIZE,
                        ID_EXPLORER_EDIT,
                        ID_EXPLORER_TOOLS,
                        ID_EXPLORER_MEDIA,
                        ID_EXPLORER_HISTORY,
                        ID_EXPLORER_MAIL,
                        ID_EXPLORER_FULLSCREEN,
                        ID_EXPLORER_DISCUSS,
                        0};

static WORD ToolId[] = { IDR_NEWMENU256,
                        16, 15,

                        ID_FILE_NEW,
                        ID_FILE_OPEN,
                        ID_FILE_SAVE,
                        ID_EDIT_CUT,
                        ID_EDIT_COPY,
                        ID_EDIT_PASTE,
                        ID_FILE_PRINT,
                        ID_APP_ABOUT,
                        ID_WINDOW_NEW,
                        ID_WINDOW_CASCADE,
                        ID_WINDOW_TILE_HORZ,
                        ID_WINDOW_TILE_VERT,
                        ID_RECORD_FIRST,
                        ID_RECORD_LAST,
                        ID_FILE_PRINT_SETUP,
                        ID_FILE_SAVE_AS,
                        ID_EDIT_REDO,
                        ID_EDIT_UNDO,
                        ID_APP_EXIT,
                        ID_EDIT_FIND,
                        ID_FILE_CLOSE,
                        ID_FILE_SEND_MAIL,
                        ID_DEFAULT_HELP,NULL};


/////////////////////////////////////////////////////////////////////////////
// CMDIApp initialization

BOOL CMDIApp::InitInstance()
{
  AfxEnableControlContainer();

  // Standard initialization
  // If you are not using these features and wish to reduce the size
  //  of your final executable, you should remove from the following
  //  the specific initialization routines you do not need.

#ifdef _AFXDLL
  Enable3dControls();     // Call this when using MFC in a shared DLL
#else
  Enable3dControlsStatic(); // Call this when linking to MFC statically
#endif

  // Change the registry key under which our settings are stored.
  // TODO: You should modify this string to be something appropriate
  // such as the name of your company or organization.
  SetRegistryKey(_T("New Menu Sample"));

  LoadStdProfileSettings();  // Load standard INI file options (including MRU)

  // Register the application's document templates.  Document templates
  //  serve as the connection between documents, frame windows and views.

  CNewMultiDocTemplate* pDocTemplate;
  pDocTemplate = new CNewMultiDocTemplate(
    IDR_MDITYPE,
    RUNTIME_CLASS(CMDIDoc),
    RUNTIME_CLASS(CChildFrame), // custom MDI child frame
    RUNTIME_CLASS(CMDIView));
  AddDocTemplate(pDocTemplate);

  pDocTemplate->m_NewMenuShared.LoadToolBar(IDR_DRAWBAR); 
  pDocTemplate->m_NewMenuShared.LoadToolBar(ToolId,RGB(192,192,192)); 

  pDocTemplate->m_NewMenuShared.SetBitmapBackground(RGB(0,0,0));
  pDocTemplate->m_NewMenuShared.LoadToolBar(ToolId2);

  pDocTemplate->m_NewMenuShared.ModifyODMenu(0,_T("More A"),IDB_MORE_C);
  //pDocTemplate->m_NewMenuShared.ModifyODMenu(0,_T("More A"),IDB_MORE_A);
  pDocTemplate->m_NewMenuShared.ModifyODMenu(0,_T("More B"),IDB_MORE_B);

  // Try to set a title to NewMenu menu
  CNewMenu* pNewMenu = DYNAMIC_DOWNCAST(CNewMenu,pDocTemplate->m_NewMenuShared.GetSubMenu(_T("New&Menu")));
  if(pNewMenu)
  {
    pNewMenu->SetMenuTitle(_T("New Menu"),MFT_SIDE_TITLE|MFT_LINE|MFT_CENTER|MFT_GRADIENT);
  }

  CNewMenu::SetMenuDrawMode(GetProfileInt(_T("NewMenu"),_T("Style"),2));
  CNewMenu::SetSelectDisableMode(GetProfileInt(_T("NewMenu"),_T("Selection"),1));
  CNewMenu::SetXpBlendig(GetProfileInt(_T("NewMenu"),_T("Gloom"),1));

  // create main MDI Frame window
  CMainFrame* pMainFrame = new CMainFrame;
  if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
    return FALSE;
  m_pMainWnd = pMainFrame;

  // Parse command line for standard shell commands, DDE, file open
  CCommandLineInfo cmdInfo;
  ParseCommandLine(cmdInfo);

  // Dispatch commands specified on the command line
  if (!ProcessShellCommand(cmdInfo))
    return FALSE;

  // The main window has been initialized, so show and update it.
  pMainFrame->ShowWindow(m_nCmdShow);
  pMainFrame->UpdateWindow();

  return TRUE;
}


void CMDIApp::OnFileOpen()
{
  // Subclass dialog with system menu
  CNewMenuHelper myHelper(NEW_MENU_DIALOG_SUBCLASS|NEW_MENU_DIALOG_SYSTEM_MENU);
  CWinApp::OnFileOpen();
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CNewDialog
{
public:
  CAboutDlg();

// Dialog Data
  //{{AFX_DATA(CAboutDlg)
  enum { IDD = IDD_ABOUTBOX };
  //}}AFX_DATA

  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CAboutDlg)
  protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL

// Implementation
protected:
  //{{AFX_MSG(CAboutDlg)
    // No message handlers
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CNewDialog(CAboutDlg::IDD)
{
  //{{AFX_DATA_INIT(CAboutDlg)
  //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
  CNewDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CAboutDlg)
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CNewDialog)
  //{{AFX_MSG_MAP(CAboutDlg)
    // No message handlers
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMDIApp::OnAppAbout()
{
  CAboutDlg aboutDlg;
  aboutDlg.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CMDIApp message handlers

