// MDIFloatingView.cpp : implementation of the CMDIFloatingView class
//

#include "stdafx.h"
#include "MDIFloating.h"

#include "MDIFloatingDoc.h"
#include "MDIFloatingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMDIFloatingView

IMPLEMENT_DYNCREATE(CMDIFloatingView, CEditView)

BEGIN_MESSAGE_MAP(CMDIFloatingView, CEditView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
  ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()

// CMDIFloatingView construction/destruction

CMDIFloatingView::CMDIFloatingView()
{
	// TODO: add construction code here

}

CMDIFloatingView::~CMDIFloatingView()
{
}

BOOL CMDIFloatingView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}


// CMDIFloatingView printing

BOOL CMDIFloatingView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CEditView preparation
	return CEditView::OnPreparePrinting(pInfo);
}

void CMDIFloatingView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView begin printing
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CMDIFloatingView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView end printing
	CEditView::OnEndPrinting(pDC, pInfo);
}


// CMDIFloatingView diagnostics

#ifdef _DEBUG
void CMDIFloatingView::AssertValid() const
{
	CEditView::AssertValid();
}

void CMDIFloatingView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CMDIFloatingDoc* CMDIFloatingView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMDIFloatingDoc)));
	return (CMDIFloatingDoc*)m_pDocument;
}
#endif //_DEBUG

static CString GetShort(UINT id)
{
	CString str;
	str.LoadString(id);
	int nIndex = str.ReverseFind(_T('\n'));
	if(nIndex!=-1)
	{
		str=str.Mid(nIndex+1);
	}
	return str;
}

// CMDIFloatingView message handlers

void CMDIFloatingView::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	if(point.x==-1 && point.y==-1)
	{
		CRect rect;
		GetWindowRect(rect);

		point = rect.TopLeft()+CPoint(10,10);
	}
	SetFocus();

	CNewMenu menu;
  if(0)
  {
    menu.LoadMenu(IDR_MAINFRAME);
    CNewMenu *menupop;
    menupop=(CNewMenu *)menu.GetSubMenu(0);
    CPoint ptScreen=point;
    CString str1,str2;
    menu.GetMenuString(0,str1,MF_BYPOSITION);
    menu.GetMenuText(0,str2,MF_BYPOSITION);

    MessageBox(str1+CString("==")+str2);//then str1 is empty and str2 is right
	  menupop->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, AfxGetMainWnd());
  }
  else
  {
	  menu.CreatePopupMenu();
	  menu.InsertMenu(0, MF_BYPOSITION , ID_EDIT_UNDO, GetShort(ID_EDIT_UNDO));
	  menu.InsertMenu(1, MF_BYPOSITION|MF_SEPARATOR);
	  menu.InsertMenu(2, MF_BYPOSITION , ID_EDIT_COPY, GetShort(ID_EDIT_COPY));
	  menu.InsertMenu(2, MF_BYPOSITION , ID_EDIT_CUT, GetShort(ID_EDIT_CUT));
	  menu.InsertMenu(4, MF_BYPOSITION , ID_EDIT_CLEAR, GetShort(ID_EDIT_CLEAR));
	  menu.InsertMenu(5, MF_BYPOSITION , ID_EDIT_PASTE, GetShort(ID_EDIT_PASTE));
	  menu.InsertMenu(6, MF_BYPOSITION|MF_SEPARATOR);

	  menu.InsertMenu(7, MF_BYPOSITION , ID_EDIT_SELECT_ALL,GetShort(ID_EDIT_SELECT_ALL));

	  menu.SetMenuTitle(_T("Edit commands"),MFT_GRADIENT|MFT_SIDE_TITLE);
	  menu.LoadToolBar(IDR_MAINFRAME);

	  menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, AfxGetMainWnd());
  }
}
