// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "SDI.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CNewFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CNewFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_NEWMENU_NEXTSTYLE, OnNewMenuNextStyle)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_NEXTSTYLE, OnUpdateNewMenuNextStyle)
	ON_COMMAND(ID_NEWMENU_SHOWSELECTION, OnNewMenuShowSelection)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_SHOWSELECTION, OnUpdateNewMenuShowSelection)
	ON_COMMAND(ID_NEWMENU_NORMALBORDER, OnNewMenuNormalBorder)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_NORMALBORDER, OnUpdateNewMenuNormalBorder)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_NEWMENU_ENABLEGLOOM, OnNewMenuEnableGloom)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_ENABLEGLOOM, OnUpdateNewMenuEnableGloom)
  ON_COMMAND(ID_NEWMENU_ALLMENUSAMEBORDER, OnNewMenuAllSameBorder)
  ON_UPDATE_COMMAND_UI(ID_NEWMENU_ALLMENUSAMEBORDER, OnUpdateNewMenuAllSameBorder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

static WORD ToolId[] = { IDR_NEWMENU256,
                        16, 15,

                        ID_FILE_NEW,
                        ID_FILE_OPEN,
                        ID_FILE_SAVE,
                        ID_EDIT_CUT,
                        ID_EDIT_COPY,
                        ID_EDIT_PASTE,
                        ID_FILE_PRINT,
                        ID_APP_ABOUT,
                        ID_WINDOW_NEW,
                        ID_WINDOW_CASCADE,
                        ID_WINDOW_TILE_HORZ,
                        ID_WINDOW_TILE_VERT,
                        ID_RECORD_FIRST,
                        ID_RECORD_LAST,
                        ID_FILE_PRINT_SETUP,
                        ID_FILE_SAVE_AS,
                        ID_EDIT_REDO,
                        ID_EDIT_UNDO,
                        ID_APP_EXIT,
                        ID_EDIT_FIND,
                        ID_FILE_CLOSE,
                        ID_FILE_SEND_MAIL,
                        ID_DEFAULT_HELP,NULL};


/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CNewFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_DefaultNewMenu.LoadToolBar(ToolId,RGB(192,192,192));
	m_SystemNewMenu.SetMenuTitle(_T("SDI Sample"),MFT_LINE|MFT_CENTER|MFT_ROUND);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CNewFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CNewFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CNewFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnNewMenuNextStyle() 
{
	int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2)+2;

	if(nStyle>CNewMenu::STYLE_ICY_NOBORDER)
		nStyle = CNewMenu::STYLE_ORIGINAL+(nStyle&1);

	int nActStyle = CNewMenu::GetMenuDrawMode();
	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Style"),nStyle);
	if(nActStyle!=nStyle)
	{
    // Subclass dialog with system menu
    CNewMenuHelper myHelper(NEW_MENU_DIALOG_SUBCLASS|NEW_MENU_DIALOG_SYSTEM_MENU);
		AfxMessageBox(_T("You must restart the application for changing the menu style"),MB_OK);
	}
}

void CMainFrame::OnUpdateNewMenuNextStyle(CCmdUI* pCmdUI) 
{
	int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2);
	int nActStyle = CNewMenu::GetMenuDrawMode();
	pCmdUI->SetCheck(nStyle==nActStyle);
	switch(nStyle)
	{
	case CNewMenu::STYLE_ORIGINAL:
		pCmdUI->SetText(_T("Original new border"));
		break;

  case CNewMenu::STYLE_ORIGINAL_NOBORDER:
		pCmdUI->SetText(_T("Original old border"));
		break;

	case CNewMenu::STYLE_ICY:
		pCmdUI->SetText(_T("Icy new border"));
		break;

  case CNewMenu::STYLE_ICY_NOBORDER:
		pCmdUI->SetText(_T("Icy old border"));
		break;

  case CNewMenu::STYLE_XP:
		pCmdUI->SetText(_T("XP new border"));
		break;

  case CNewMenu::STYLE_XP_NOBORDER:
		pCmdUI->SetText(_T("XP old border"));
		break;

  case CNewMenu::STYLE_SPECIAL:
		pCmdUI->SetText(_T("Special new border"));
		break;

	case CNewMenu::STYLE_SPECIAL_NOBORDER:
		pCmdUI->SetText(_T("Special old border"));
		break;
	}
}

void CMainFrame::OnNewMenuShowSelection() 
{
	BOOL bMode = CNewMenu::GetSelectDisableMode()?FALSE:TRUE;
	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Selection"),bMode);
	CNewMenu::SetSelectDisableMode(bMode);
}

void CMainFrame::OnUpdateNewMenuShowSelection(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(CNewMenu::GetSelectDisableMode());
}

void CMainFrame::OnNewMenuNormalBorder() 
{
	int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2);

	int nActStyle = CNewMenu::GetMenuDrawMode()&~1;
	CNewMenu::SetMenuDrawMode(nActStyle|((nStyle^1)&1));

	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Style"),nStyle^1);
}

void CMainFrame::OnUpdateNewMenuNormalBorder(CCmdUI* pCmdUI) 
{
	pCmdUI->SetRadio(TRUE);
	if(CNewMenu::GetMenuDrawMode()&1)
	{
		pCmdUI->SetText(_T("Old border"));
	}
	else
	{
		pCmdUI->SetText(_T("New border"));
	}
}

void CMainFrame::OnNewMenuEnableGloom() 
{
  CNewMenu::SetXpBlendig(CNewMenu::GetXpBlendig()?FALSE:TRUE);
	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Gloom"),CNewMenu::GetXpBlendig());
}

void CMainFrame::OnUpdateNewMenuEnableGloom(CCmdUI* pCmdUI) 
{
  if(CNewMenu::GetMenuDrawMode()==CNewMenu::STYLE_XP ||
     CNewMenu::GetMenuDrawMode()==CNewMenu::STYLE_XP_NOBORDER)
  {
    pCmdUI->Enable(TRUE);
  }
  else
  {
    pCmdUI->Enable(FALSE);
  }
  pCmdUI->SetCheck(CNewMenu::GetXpBlendig());
}

void CMainFrame::OnNewMenuAllSameBorder()
{
  CNewMenu::SetNewMenuBorderAllMenu(CNewMenu::GetNewMenuBorderAllMenu()?FALSE:TRUE);
}

void CMainFrame::OnUpdateNewMenuAllSameBorder(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(CNewMenu::GetNewMenuBorderAllMenu());
}
